#include "Fahrrad.h"

// Konstanten-Definition
#define REL_FAHRRADVERLANGSAMUNG		0.05
#define STRECKE_FUER_VERLANGSAMUNG	15
#define	MIN_GESCHWINDIGKEIT					10


Fahrrad::Fahrrad(void)
{
}

Fahrrad::Fahrrad(string sName) : Fahrzeug(sName) {};

// Aufruf der Vorgnger-Constructors, da Fahrrad keine weiteren Member-Variablen hat
Fahrrad::Fahrrad(string sName, double dMaxGeschwindigkeit) : Fahrzeug(sName, dMaxGeschwindigkeit) {};



double Fahrrad::dGeschwindigkeit(void)
{
	double dAktGeschwindigkeit;	// Hilfsvariable, die die theoretische akt. Gechwindigkeit speichert

	dAktGeschwindigkeit = p_dMaxGeschwindigkeit * 
		(1 - (p_dGesamtStrecke / STRECKE_FUER_VERLANGSAMUNG * REL_FAHRRADVERLANGSAMUNG));
	
	if (dAktGeschwindigkeit < MIN_GESCHWINDIGKEIT)		// Fahrrder defen nicht langsamer als 10 km/h fahren
	{
		dAktGeschwindigkeit = MIN_GESCHWINDIGKEIT;
	}
	return dAktGeschwindigkeit;
}


void Fahrrad::vAbfertigung(void) 
{
	extern double dGlobaleZeit;					// Benutze die globale Zeit

/*	p_dZeit ist zu Beginn mit 0 initialisiert. Beim ersten Aufruf mit dGlobalZeit != 0 wird die Abfertigung
		ausgefhrt und die aktuelle Zeit in p_dZeit gespeichert. Wird nun diese Funktion im selben Zeitabschnitt ein
		weiteres Mal aufgerufen, so ist die Ungeleichung nicht mehr erfuellt und es wird nichts getan.
		Nach Abflauf der Abfertigung wird die aktuelle Zeit als Zeitpunkt der letzten Abfertigung un p_dZeit gespeichert.*/
	
	if (dGlobaleZeit > p_dZeit)					
	{
		p_dGesamtStrecke += (dGlobaleZeit - p_dZeit) * dGeschwindigkeit();  // Gesamt-Strecke aufaddieren
		p_dGesamtZeit += dGlobaleZeit - p_dZeit;	// Gesamt-Zeit aufaddieren
		p_dZeit = dGlobaleZeit;	// letzte Ausfuehrungszeit speichern
	}
}

void Fahrrad::vAusgabe(void)
{
	Fahrzeug::vAusgabe();							// Vorgaenger-Ausgabe aufrufen
	cout << resetiosflags(ios::left) << setiosflags(ios::right);
	cout << setw(13) << "=";					// Platz lassen fuer die Ausgaben von PKW
	cout << setw(12) << "=";
	cout << setiosflags(ios::fixed) << setprecision(2);
	cout << setw(14) << dGeschwindigkeit(); 
	cout << resetiosflags(ios::left);
}


ostream& Fahrrad::osAusgabe(ostream &osOut)
{
	Fahrzeug::osAusgabe(osOut);							// Vorgaenger-Ausgabe aufrufen
	osOut << resetiosflags(ios::left) << setiosflags(ios::right);
	osOut << setw(13) << "=";					// Platz lassen fuer die Ausgaben von PKW
	osOut << setw(12) << "=";
	osOut << setiosflags(ios::fixed) << setprecision(2);
	osOut << setw(14) << dGeschwindigkeit(); 
	osOut << resetiosflags(ios::left);
	return osOut;
}

Fahrrad::Fahrrad (Fahrrad& FahrradVorlage)	// Copy-Contructor
: Fahrzeug(FahrradVorlage)
{
}


Fahrrad::~Fahrrad(void)
{
}
