#ifndef __FAHRZEUG_H
	#include "Fahrzeug.h"
#endif


//#define DEBUG_6_4_3_3			// Zum Test der Kon-/Destruktoren: cout-Ausgabe

int Fahrzeug::p_iMaxID = 0;	// Startwert der IDs fuer jedes Fahrzeug

Fahrzeug::Fahrzeug(void)		// simple Contructor
{
	vInitialisierung();
	#ifdef DEBUG_6_4_3_3
		cout <<"Fahrzeug " << " mit Nummer " << p_iID << " erstellt." << endl;
	#endif
}

Fahrzeug::Fahrzeug(string sName)	// Name des Fahrzeugs kann uebergeben werden
{
	vInitialisierung();
	p_sName = sName;
	#ifdef DEBUG_6_4_3_3
		cout <<"Fahrzeug mit Namen " << p_sName << " und Nummer " << p_iID << " erstellt." << endl;
	#endif
}

Fahrzeug::Fahrzeug(string sName, double dMaxGeschwindigkeit)  // Name und max. Geschw. werden gesetzt
{
	vInitialisierung();
	p_sName = sName;
	p_dMaxGeschwindigkeit = dMaxGeschwindigkeit;
	#ifdef DEBUG_6_4_3_3
		cout <<"Fahrzeug mit Namen " << p_sName << " und Nummer " << p_iID << " erstellt." << endl;
	#endif
}


Fahrzeug::~Fahrzeug(void)	// Destruktor
{
	#ifdef DEBUG_6_4_3_3
		cout << "Fahrzeug mit Namen " << p_sName << " und Nummer " << p_iID << " entfernt." << endl;
	#endif
}

void Fahrzeug::vInitialisierung(void)		// Initialisierung aller Data Members
{
	p_sName = "";
	p_iID = ++p_iMaxID;										// ID-Zaehler um 1 erhoehen und dem aktuellen Objekt zuweisen
	p_dMaxGeschwindigkeit = 0.0;					// Variablen init.
	p_dGesamtStrecke = 0.0;
	p_dGesamtZeit = 0.0;
	p_dZeit = 0.0;

}


double Fahrzeug::GetGesamtStrecke(void) // Hilfsfunktion zur Rckgabe von p_dGesamtStrecke
{
	return p_dGesamtStrecke;
}


void Fahrzeug::vAusgabe(void)						// Text-Ausgabe, passend zur Tabellen-Ueberschrift in main.cpp formatiert
{
	cout << endl << resetiosflags(ios::right) << setiosflags(ios::left);
	cout << setw(5) << p_iID;
	cout << setw(10) << p_sName;
	cout << setw(1) << ":";
	cout << setw(9) << resetiosflags(ios::left) << setiosflags(ios::right) << setiosflags(ios::fixed) << setprecision(2);
	cout << p_dMaxGeschwindigkeit;  
	cout << setw(11) << p_dGesamtStrecke << resetiosflags(ios::right) << setiosflags(ios::left);
	
}

ostream& Fahrzeug::osAusgabe(ostream &osOut)
{
	osOut << endl << resetiosflags(ios::right) << setiosflags(ios::left);
	osOut << setw(5) << p_iID;
	osOut << setw(10) << p_sName;
	osOut << setw(1) << ":";
	osOut << setw(9) << resetiosflags(ios::left) << setiosflags(ios::right) << setiosflags(ios::fixed) << setprecision(2);
	osOut << p_dMaxGeschwindigkeit;  
	osOut << setw(11) << p_dGesamtStrecke << resetiosflags(ios::right) << setiosflags(ios::left);
	return osOut;
}

			    
void Fahrzeug::vAbfertigung(void)			// Abfertigung fuer jedes Fahrzeug
{
	extern double dGlobaleZeit;					// Benutze die globale Zeit

/*	p_dZeit ist zu Beginn mit 0 initialisiert. Beim ersten Aufruf mit dGlobaleZeit != 0 wird die Abfertigung
		ausgefhrt und die aktuelle Zeit in p_dZeit gespeichert. Wird nun diese Funktion im selben Zeitabschnitt ein
		weiteres Mal aufgerufen, so ist die Ungeleichung nicht mehr erfuellt und es wird nichts getan.
		Nach Abflauf der Abfertigung wird die aktuelle Zeit als Zeitpunkt der letzten Abfertigung in p_dZeit gespeichert.*/
	
	if (dGlobaleZeit > p_dZeit)					
	{
		p_dGesamtStrecke += (dGlobaleZeit - p_dZeit) * p_dMaxGeschwindigkeit;  // Gesamt-Strecke aufaddieren
		p_dGesamtZeit += dGlobaleZeit - p_dZeit;	// Gesamt-Zeit aufaddieren
		p_dZeit = dGlobaleZeit;	// letzte Ausfuehrungszeit speichern
	}
}


bool Fahrzeug::operator< (Fahrzeug& VergleichFahrzeugRef)	// berladener Vergeleichsoperator
{
  return (p_dGesamtStrecke < VergleichFahrzeugRef.GetGesamtStrecke());
}


Fahrzeug::Fahrzeug (Fahrzeug& FahrzeugVorlage)			// Copy-Konstructor
{
	p_iID = ++p_iMaxID;
	p_sName = FahrzeugVorlage.p_sName;
	p_dMaxGeschwindigkeit = FahrzeugVorlage.p_dMaxGeschwindigkeit;
	p_dGesamtStrecke = FahrzeugVorlage.p_dGesamtStrecke;
	p_dGesamtZeit = FahrzeugVorlage.p_dGesamtZeit;
	p_dZeit = FahrzeugVorlage.p_dZeit;
}

Fahrzeug& Fahrzeug::operator= (Fahrzeug& FahrzeugVorlage)
{
	cout << "= Operator ist hier verboten";
	exit (43);
}


ostream& operator<< (ostream& osOut, Fahrzeug& FahrzeugRef)
{
	return FahrzeugRef.osAusgabe(osOut);
}
