#pragma once


#ifndef __string
	#include <string>
#endif

#ifndef __iostream
	#include <iostream>
#endif

#ifndef __iomanip
	#include <iomanip>
#endif


#ifndef __FAHRZEUG_H
	#define __FAHRZEUG_H
#endif

using namespace std;

class Fahrzeug
{
private:
	string p_sName;									// Name des Fahrzeugs
	int p_iID;											// ID des Fahrzeugs (eindeutig)
	static int p_iMaxID;						// Zhler fr ID
	void vInitialisierung(void);		// Initialisierung der Variablen
	
	
protected:
	double p_dMaxGeschwindigkeit;		// Maximales Geschwindigkeit
	double p_dGesamtStrecke;				// Gesamte gefahrene Srecke
	double p_dGesamtZeit;						// Gesamte Zeit, whrend das Fahrzeug
	double p_dZeit;									// Zeitstempel des letzten Abfertigung

	

public:
	// Constructor
	Fahrzeug(void);
	Fahrzeug(string sName);
	Fahrzeug(string sName, double dMaxGeschwindigkeit);

	// Destructor
	virtual ~Fahrzeug(void);


	// Hilfsfunktion zur Rckgabe von p_dGesamtStrecke
	double GetGesamtStrecke(void);

	// Schreibt tabellenartig die internen Variablen auf die Ausgabe
	virtual void vAusgabe(void);

	// berladener ostream
	virtual ostream& osAusgabe(ostream &osOut);

	// Sorgt fuer die Bearbeitung der inneren Zustaende der Fahrzeuge
	virtual void vAbfertigung(void);								

	// Tankt das Fahrzeug
	virtual double dTanken(double dMenge = 0.0) {return 0.0;};

	// Geschwindigkeit setzen
	virtual double dGeschwindigkeit(void) {return 0.0;};	


	// Dient dem Vergleich der bisher zurueckgelegten Gesamtstrecke, liefert true wenn diese kleiner ist als die 
	// zurueckgelegte Gesamtstrecke des angegebene Fahrzeugs.
	bool operator< (Fahrzeug& VergleichFahrzeugRef);

	
/*	Meine Entscheidung ist derart ausgefallen, dass ich sowohl den Zuweisung-Operator als auch den Copy-Kontructor
		weiterhin zulasse, aber die IDs der neu erzeugten Objekte automatich hochgezaehlt wird.
		Die Methoden sind virtual, weil sie in den abgeleiteten Klassen angepasst werden mssen. */

	Fahrzeug (Fahrzeug& FahrzeugVorlage);			// Copy-Konstructor
	virtual Fahrzeug& operator= (Fahrzeug& FahrzeugVorlage);

};


// Dient zur Ausgabe von Fahrzeugdaten
ostream& operator<< (ostream& osOut, Fahrzeug& FahrzeugRef);

