#include "PKW.h"

PKW::PKW(void)
{
}


PKW::PKW(string sName, double dMaxGeschwindigkeit,  double dVerbrauch, double dTankvolumen)
// Konstruktor, der ebenfalls das Tankvolumen setzt
 :Fahrzeug(sName, dMaxGeschwindigkeit)  //Aufruf des Vorgaenger-Konstruktors
{
  p_dTankvolumen = dTankvolumen;
	p_dTankinhalt = dTankvolumen / 2;	// auf halbes Tankvolumen vortanken
	p_dVerbrauch = dVerbrauch; 

}
double PKW::dVerbrauch(void)
{// Rueckgabe des bisherigen Gesamtverbrauchs
  return p_dGesamtStrecke * p_dVerbrauch / 100;
}

double PKW::dTanken(double dMenge)	// Tanken, default ist "Volltanken"
{
	double dVollZutanken;

	dVollZutanken = p_dTankvolumen - p_dTankinhalt;
	if ((dMenge == 0.0) ||															// Wenn volltanken gewnscht ist, oder
			((dMenge + p_dTankinhalt) >= p_dTankvolumen))		// mehr zu tanken wre, als in den Tank passt
	{
		p_dTankinhalt = p_dTankvolumen;		// Tank auf Maximum
		return dVollZutanken;							// Differenz zwischen altem Stand und Maximalwert
	}
	else	// Bestimmte Menge tanken, die auch passt
	{
		p_dTankinhalt += dMenge;				// geschwuenschte Menge zutanken
		return dMenge;									// diese auch zurueckliefern
	}
}


void PKW::vAbfertigung(void)
{
	extern double dGlobaleZeit;					// Benutze die globale Zeit

/*	p_dZeit ist zu Beginn mit 0 initialisiert. Beim ersten Aufruf mit dGlobalZeit != 0 wird die Abfertigung
		ausgefhrt und die aktuelle Zeit in p_dZeit gespeichert. Wird nun diese Funktion im selben Zeitabschnitt ein
		weiteres Mal aufgerufen, so ist die Ungeleichung nicht mehr erfuellt und es wird nichts getan.
		Nach Abflauf der Abfertigung wird die aktuelle Zeit als Zeitpunkt der letzten Abfertigung un p_dZeit gespeichert.*/
	
	if (dGlobaleZeit > p_dZeit)					
	{
		double dStrecke;
		if (p_dTankinhalt > 0)							// Ist noch Sprit da?
		{
			dStrecke = p_dGesamtStrecke;			// Wert zwischenspeichern
			Fahrzeug::vAbfertigung();					// Vorgaenger-Abfertigung aufrufen
			dStrecke = p_dGesamtStrecke - dStrecke;
			p_dTankinhalt -= dStrecke / 100 * p_dVerbrauch;
			if (p_dTankinhalt < 0)						// Wenn Inhalt negativ, dann auf 0 setzen
			{
				p_dTankinhalt = 0;
			}
		}
	}
}

void PKW::vAusgabe(void)
{
	Fahrzeug::vAusgabe();							// Vorgaenger-Ausgabe aufrufen
	cout << setw(15) << resetiosflags(ios::left) << setiosflags(ios::right) << setiosflags(ios::fixed) << setprecision(2);
	cout << dVerbrauch(); 
	cout << setw(12) << p_dTankinhalt;
	cout << setw(10) << "=";
	cout << resetiosflags(ios::right) << setiosflags(ios::left);
}

ostream& PKW::osAusgabe(ostream &osOut)
{
	Fahrzeug::osAusgabe(osOut);							// Vorgaenger-Ausgabe aufrufen
	osOut << setw(15) << resetiosflags(ios::left) << setiosflags(ios::right) << setiosflags(ios::fixed) << setprecision(2);
	osOut << dVerbrauch(); 
	osOut << setw(12) << p_dTankinhalt;
	osOut << setw(10) << "=";
	osOut << resetiosflags(ios::right) << setiosflags(ios::left);
	return osOut;
}

double PKW::dGeschwindigkeit(void)
{
	return p_dMaxGeschwindigkeit;	// PKW fhrt immer mit Maximal-Geschwindigkeit
}

PKW::PKW (PKW& PKWVorlage)// Copy-Konstructor
: Fahrzeug(PKWVorlage)
{
	p_dVerbrauch = PKWVorlage.p_dVerbrauch;
	p_dTankinhalt = PKWVorlage.p_dTankinhalt;
	p_dTankvolumen = PKWVorlage.p_dTankvolumen;
}


PKW::~PKW(void)
{
}
