#pragma once
#include "fahrzeug.h"


class PKW :
	public Fahrzeug
{
private:
	double p_dVerbrauch;					// Verbrauchs-Rate Liter auf 100 km
	double p_dTankinhalt;					// aktueller Tankinhalt in Litern
	double p_dTankvolumen;				// = max. Tankinhalt

public:
	
	PKW(void);
	
	// Constructor, der ebenfalls das Tankvolumen setzt
	PKW(string sName, double dMaxGeschwindigkeit,  double dVerbauch, double dTankvolumen = 40.0);

	// Copy-Constructor
	PKW (PKW& PKWVorlage);

	// Destructor
	virtual ~PKW(void);


	// Rueckgabe des bisherigen Gesamtverbrauchs
	double dVerbrauch(void);

	// PKW betanken, default ist "Volltanken"
	virtual double dTanken(double dMenge = 0.0);

	// PKW abfertigen
	virtual void vAbfertigung(void);

	// PKW-Daten als Text ausgeben
	virtual void vAusgabe(void);
	
	// Umleitung des ostream
	virtual ostream& osAusgabe(ostream &osOut);

	// aktuelle Geschwindigkeit des PKW
	virtual double dGeschwindigkeit(void);
};
