// main.cpp : Definiert den Einstiegspunkt fr die Konsolenanwendung.
//

#include "stdafx.h"
#ifndef __Fahrzeug_H
	#include "Fahrzeug.h"
#endif
#include <vector>

#ifndef __PKW_H
	#include "PKW.h"
#endif

#ifndef __FAHRRAD_H
	#include "Fahrrad.h"
#endif
	




#define DEBUG

//#define DEBUG_6_4_3_3			// Fr Aufgabe 6.4.3.3 aktivieren
//#define DEBUG_6_4_3_10		// Fr Aufgabe 6.4.3.10 aktivieren

#define ZEITSCHRITT 0.25				// Zeitschrittweite fuer die Simulation in Stunden
#define AUSFUEHRUNGSDAUER 3			// Gesamt-Dauer der Simulation in Stunden
#define TANKZEIT 2.5


void vAusgabeTabellenUeberschrift(void);	// Gibt die Tabellen-berschrift fuer vAusgabe_1 aus
void vAufgabe_1(void);										// Aufgabe_1
void vAufgabe_1_deb(void);								// Debug-Version mit Zugriff auf Nullzeiger
void vAufgabe_2(void);
void vAufgabe_3(void);



double dGlobaleZeit = 0.0; // Zeitstempel, durchgehend im Projekt

void vAusgabeTabellenUeberschrift(void) 
{ // Gibt die Tabellen-berschrift von vAusgabe

	cout << endl;
	cout << resetiosflags(ios::right);
	cout << setw(5)  << setiosflags(ios::left) << "ID";
	cout << setw(10) << "Name";
	cout << setw(5)	 << ":";
	cout << setw(8)  << "MaxKmh";
	cout << setw(14) << "Ges. Strecke";
	cout << setw(17) << "Ges. Verbrauch";
	cout << setw(8)  <<	"Tank";
	cout << setw(12) << "Akt. Geschw." << endl;
	cout << setw(79) << "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" << endl;
}

void vAufgabe_1_deb(void)
{
	Fahrzeug *FahrzeugeFeld[4];			// Feld fr die Zeiger auf Objekte

	FahrzeugeFeld[0] = new Fahrzeug("DynFahrz1", 40.0);	// Objekte erzeugen
	FahrzeugeFeld[1] = new Fahrzeug("DynFahrz2", 50.0);
	FahrzeugeFeld[2] = new Fahrzeug("DynFahrz3", 60.0);
	FahrzeugeFeld[3] = new Fahrzeug("DynFahrz4", 80.0);

	vAusgabeTabellenUeberschrift();
	for (int i = 0; i <= 3; i++)
	{
		FahrzeugeFeld[i]->vAusgabe();			// Objekte ausgeben
	}

	cout << endl << endl;

	FahrzeugeFeld[2] = 0;						// Hier wird der Fehler eingebaut
	for (int i = 0; i <= 3; i++)
	{
		FahrzeugeFeld[i]->vAusgabe();			// Versuch der Ausgabe
	}

	for (int i = 0; i <= 3; i++)
	{
		delete FahrzeugeFeld[i];				// Dyn. erzeugte Objekte lschen
	}
}


void vAufgabe_1(void)
{
	#ifdef DEBUG_6_4_3_3		// Aufgabenteil 6.4.3.3
		string sEingabe;

		cout << "Bitte Namen fr das 1. statisch erzeugte Fahrzeug eingeben: ";
		cin >> sEingabe;
		Fahrzeug Fahrzeug1_Stat (sEingabe);

		cout << "Bitte Namen fr das 2. statisch erzeugte Fahrzeug eingeben: ";
		cin >> sEingabe;
		Fahrzeug Fahrzeug2_Stat (sEingabe);

		cout << "Bitte Namen fr das 1. dynamisch erzeugte Fahrzeug eingeben: ";
		cin >> sEingabe;
		Fahrzeug *Fahrzeug3_Dyn = new Fahrzeug(sEingabe);

		cout << "Bitte Namen fr das 2. dynamisch erzeugte Fahrzeug eingeben: ";
		cin >> sEingabe;
		Fahrzeug *Fahrzeug4_Dyn = new Fahrzeug(sEingabe);
	#else
		Fahrzeug Fahrzeug1_Stat ("StatFahrz", 40.0);	// Alternativ-Code fr alle anderen Flle
		Fahrzeug Fahrzeug2_Stat ("StatFahrz2", 50.0);	// erzeugt statische Fahrzeuge
		Fahrzeug Fahrzeug3_Stat ("StatFahrz3", 60.0);
		Fahrzeug Fahrzeug4_Stat ("StatFahrz4", 80.0);
	#endif

// -------------------------------------------------------------------------------------
// Haupt-Zeitschleife
// -------------------------------------------------------------------------------------

	for (dGlobaleZeit = 0; dGlobaleZeit <= AUSFUEHRUNGSDAUER; dGlobaleZeit += ZEITSCHRITT) 
	{
		#ifndef DEBUG_6_4_3_3	// Fuer Aufgabenteil alles auer 6.4.3.3
			Fahrzeug1_Stat.vAbfertigung();	// Fahrzeuge abfertigen
			Fahrzeug2_Stat.vAbfertigung();
			Fahrzeug3_Stat.vAbfertigung();
			Fahrzeug4_Stat.vAbfertigung();
		#endif 
			
		vAusgabeTabellenUeberschrift();		// Tabellen-berschrift ausgeben

		#ifdef DEBUG_6_4_3_3							// Aufgabenteil 6.4.3.3
			Fahrzeug1_Stat.vAusgabe();			// Angepasster Aufruf
			Fahrzeug2_Stat.vAusgabe();
			Fahrzeug3_Dyn->vAusgabe();
			Fahrzeug4_Dyn->vAusgabe();
		#else
			Fahrzeug1_Stat.vAusgabe();			// Aufruf fr statisch erzeugte Objekte
			Fahrzeug2_Stat.vAusgabe();
			Fahrzeug3_Stat.vAusgabe();
			Fahrzeug4_Stat.vAusgabe();
		#endif
		cout << endl;
	}

	#ifdef DEBUG_6_4_3_3								// dyn. erzeugte Objekte muessen wieder freigegeben werden
		delete Fahrzeug4_Dyn;
		delete Fahrzeug3_Dyn;
	#endif
}

void vAufgabe_2(void)
{
	int iAnzahlPKW;
	int iAnzahlFahrrad;
	vector<Fahrzeug*> FahrzeugVector;
	bool bGetankt = false;

	#ifndef DEBUG
		cout << endl;
		cout << "Bitte die Anzahl der PKW eingeben: ";
		cin >> iAnzahlPKW;
		cout << "Bitte die Anzahl der Fahrraeder eingeben: ";
		cin >> iAnzahlFahrrad;
	#else
		iAnzahlPKW = 2;
		iAnzahlFahrrad = 2;
		cout << iAnzahlPKW << " PKW, " << iAnzahlFahrrad << " Fahrraeder " << endl;
	#endif

	for (int i = 0; i < iAnzahlPKW; i++)
	{
		FahrzeugVector.push_back(new PKW("PKW", 50*(i+1), 10));
	}

	for (int i = 0; i < iAnzahlFahrrad; i++)
	{
		FahrzeugVector.push_back(new Fahrrad("Fahrrad", 15+i*5));
	}
	

	for (dGlobaleZeit = 0; dGlobaleZeit <= AUSFUEHRUNGSDAUER; dGlobaleZeit += ZEITSCHRITT) 
	{
		vAusgabeTabellenUeberschrift();		// Tabellen-berschrift ausgeben
	
		for (unsigned int i = 0; i < FahrzeugVector.size(); i++)
		{		
			if (((dGlobaleZeit - TANKZEIT) >= 0) && !bGetankt)
			{
				FahrzeugVector[i]->dTanken();
				bGetankt = true;
			}
			FahrzeugVector[i]->vAbfertigung();
			FahrzeugVector[i]->vAusgabe();
		}
		cout << endl <<endl;
		cout << "---------------------------------Zeit: ";
		cout << setw(6) << resetiosflags(ios::left) << setiosflags(ios::right) << setiosflags(ios::fixed) << setprecision(2);
		cout << dGlobaleZeit;
		cout << resetiosflags(ios::right);
		cout << "-----------------------------------" << endl << endl;
	}
}

void vAufgabe_3(void)
{	
	int iAnzahlPKW;
	int iAnzahlFahrrad;
	vector<Fahrzeug*> FahrzeugVector;
	bool bGetankt = false;

	#ifndef DEBUG
		cout << endl;
		cout << "Bitte die Anzahl der PKW eingeben: ";
		cin >> iAnzahlPKW;
		cout << "Bitte die Anzahl der Fahrraeder eingeben: ";
		cin >> iAnzahlFahrrad;
	#else
		iAnzahlPKW = 2;
		iAnzahlFahrrad = 2;
		cout << iAnzahlPKW << " PKW, " << iAnzahlFahrrad << " Fahrraeder " << endl;
	#endif

	for (int i = 0; i < iAnzahlPKW; i++)
	{
		FahrzeugVector.push_back(new PKW("PKW", 50*(i+1), 10));
	}

	for (int i = 0; i < iAnzahlFahrrad; i++)
	{
		FahrzeugVector.push_back(new Fahrrad("Fahrrad", 15+i*5));
	}
	

	for (dGlobaleZeit = 0; dGlobaleZeit <= AUSFUEHRUNGSDAUER; dGlobaleZeit += ZEITSCHRITT) 
	{
		vAusgabeTabellenUeberschrift();		// Tabellen-berschrift ausgeben
	
		for (unsigned int i = 0; i < FahrzeugVector.size(); i++)
		{		
			if (((dGlobaleZeit - TANKZEIT) >= 0) && !bGetankt)
			{
				FahrzeugVector[i]->dTanken();
				bGetankt = true;
			}
			FahrzeugVector[i]->vAbfertigung();
			cout << *FahrzeugVector[i];
		}

		cout << endl <<endl;
		cout << "---------------------------------Zeit: ";
		cout << setw(6) << resetiosflags(ios::left) << setiosflags(ios::right) << setiosflags(ios::fixed) << setprecision(2);
		cout << dGlobaleZeit;
		cout << resetiosflags(ios::right);
		cout << "-----------------------------------" << endl << endl;

		if (FahrzeugVector[2] < FahrzeugVector[1])
		{
				cout << "Fahrzeug 1 hat Fahrzeug 2 ueberholt";
		}
		else
		{
			cout << "keine Ueberholung";
		}
	}
	FahrzeugVector[1] = FahrzeugVector[0];	// 2 PKW
	FahrzeugVector[3]	= FahrzeugVector[2];	// 2 Bikes

	for (int i = 0; i < 4; i++)
	{
		cout << *FahrzeugVector[i];
	}
}

	






int _tmain(int argc, _TCHAR* argv[])
{
	long int dummy;

	#ifdef DEBUG_6_4_3_10		// Aufgabe 6.4.3.10: Debugger-Anwendung
		vAufgabe_1_deb();
	#else
//	vAufgabe_1();					// normaler Ablauf
//			vAufgabe_2();
			vAufgabe_3();
	#endif

	cout << endl << "Geben Sie zum Beenden eine Zahl ein : ";
	cin >> dummy;
	return 0;
}

